Class('ContextModalMobile')
    .extends('AbsolutePanel');
    
ContextModalMobile.__init = function( closeHandler){
    
    AbsolutePanel.prototype.__init.apply( this, [0, 0, '100%', '100%'] );
    
    this.__closeHandler = closeHandler;
    
    Bus.getInstance().get("CONTEXT_MODAL_PUSH")(this);
    
    
    this.getContainer()
        .style('z-index', '99999999999999999')
        .style('background-color', 'white');
    
    this.append(
        
        DOM.create( DOM_TAG_DIV ).append(
            this.__icon = DOM.create( DOM_TAG_DIV )
                .html("&nbsp")
                .on('click', this.__closeHandler )
                //.style('background-color', 'red')
                .style('background-size', '22px 22px')
                .style('background-position', 'center center')
                .style('background-repeat', 'no-repeat')
                .style('width', '27px')
                .style('height', '27px')
                .style('float', 'right'),
                
            this.__titleElement = DOM.create( DOM_TAG_H1 )
                .html("&nbsp;")
//                 .style("background-color", "yellow")
                .style("color", "#505050")
                .style("font-size", "14px")
                .style("text-align", "left")
                .style("padding", "5px")
        )
        
    );
    
    this.setIcon('default_close_gray');
}

ContextModalMobile.setTitle = function( title ){
    this.__titleElement.html( title || '&nbs');
}

ContextModalMobile.autoremove = function(){
    Bus.getInstance().get("CONTEXT_MODAL_POP")();
    
    AbsolutePanel.prototype.autoremove.apply(this, arguments);
}

ContextModalMobile.setIcon = function( icon ){

    var url = Path.action( SERVER.FILE.PREVIEW ).addParam('w', 44).addParam('f', icon).toURL();
    
    this.__icon.style('background-image', 'url(' + url + ')');
        
}



ContextModalMobile.updatePosition = function(){
    
}
