Class("DesktopMapManagerMobile")
    .extends("DesktopMapManager");

DesktopMapManagerMobile.__init = function(){
    
    DesktopMapManager.prototype.__init.apply( this, arguments );
    
    Bus.getInstance()
        .on('CLOSE_ALL_MAPS', this.fp('__closeAllLayersInCurrentDesktop'));
        
}


DesktopMapManagerMobile.__closeAllLayersInCurrentDesktop = function(){
    
    var currentDashboard = Bus.getInstance().get('GET_CURRENT_DASHBOARD')();
    
    Bus.getInstance().launch('SET_DESKTOP_MAP_MODE', 0, 0);
        
    delete this.__currentFocus[ currentDashboard ];
        
    Bus.getInstance().launch('OPEN_MAIN_SCREEN');
    
}


DesktopMapManagerMobile.__updatePositions = function(){


	if( window.innerWidth < window.innerHeight ){
	
		var left = 0;
		var right = 0;
		
	 	var legend = this.__legendIconService.status() ? 50 : 0;
        

		for( var i = 0; i < this.__mapContainers.length; i++ )
			if( this.__mapContainers[i]  ){
				var calcW = window.innerWidth - left - right - 4;
				var calcH = window.innerHeight - 37 - 50 - legend - 4 + 8;
				
				this.__mapContainers[i].update(
					i * window.innerWidth + left /*+ 2*/,
					37,
					calcW /*+ 200*/,
					calcH
				);
				
				this.__mapContainers[i].getContainer().style('padding', '2px');
				
				if( this.__mapInstances[i] ){
					for(var j = 0; j < this.__mapInstances[i].length; j++ ){
						
						this.__mapInstances[i][j].setSize(
							( (calcW /*-4*/) / this.__mapQtds[i].x) - 4,
							( (calcH /*-4*/) / this.__mapQtds[i].y) - 4
						);
						
					}
				}
				
			}
		
	}
	
	else{
		
		var left = 0;
		var right = 0;
		
	 	var legend = this.__legendIconService.status() ? 50 : 0;

		for( var i = 0; i < this.__mapContainers.length; i++ )
			if( this.__mapContainers[i]  ){
				var calcW = window.innerWidth - left - right - 4;
				var calcH = window.innerHeight /*- 50 - 50*/ - 4 /*+ 8*/ -legend;

				this.__mapContainers[i].update(
					i * window.innerWidth + left /*+ 2*/,
					0,
					calcW /*+ 200*/,
					calcH
				);
				
				this.__mapContainers[i].getContainer().style('padding', '2px');
				
				if( this.__mapInstances[i] ){
					for(var j = 0; j < this.__mapInstances[i].length; j++ ){
						
						this.__mapInstances[i][j].setSize(
							( (calcW /*-4*/) / this.__mapQtds[i].x) - 4,
							( (calcH /*-4*/) / this.__mapQtds[i].y) - 4
						);
						
					}
				}
				
			}

	}
}
