Class('DialogChartMobile')
	.events('show_info', 'show_context_modal')
	//.extends('AbsolutePanel');
	.extends('FullMobilePanel');
	
	
	
DialogChartMobile.static.__SERVICE__ = function( config ){
    
    console.log( config );
    
	return { 
		'isAlias': false,
		'activate': DialogChartMobile.__EXECUTE__
	};
}


DialogChartMobile.static.__EXECUTE__ = function( handlerOptions, config ){

	Bus.getInstance().launch("CLOSE_ALL_WINDOWS");
	
 	var dialog = new DialogChartMobile( handlerOptions, config );
	
	dialog.on('show_info', Bus.getInstance().getLauncher('OPEN_MODAL', [dialog]));
	dialog.on('show_context_modal', dialog.fp('__showContextModal'));

}


DialogChartMobile.autoremove = function(){
	
	AbsolutePanel.prototype.autoremove.apply( this, arguments );
	
	Bus.getInstance().get('SET_WINDOW_OPEN')( false );
}


DialogChartMobile.__verifyRemoveWindow = function(){
	
	if( this.__desktop == Bus.getInstance().get('GET_CURRENT_DASHBOARD')() ){
		this.autoremove();
		
		Bus.getInstance().off('WINDOW_RESIZE', this.__onResizeHandler);
	}

}


DialogChartMobile.__init = function( handlerOptions, config ){
	
	Bus.getInstance().get('SET_WINDOW_OPEN')( true );
	
	this.__path = config.path;
	
	console.log("DialogChartMobile::__init", handlerOptions, config);
	

	this.__addSourceList = [];
	
	this.__handlerOptions = handlerOptions;
	
	var currentDashboard = Bus.getInstance().get('GET_CURRENT_DASHBOARD')();
	var left_walk = document.documentElement.clientWidth * currentDashboard;
	this.__desktop = currentDashboard;
	this.__autoRemoveHandler = this.fp('__verifyRemoveWindow');
	
	Bus.getInstance().on("CLOSE_ALL_WINDOWS", this.__autoRemoveHandler );
	

	FullMobilePanel.prototype.__init.apply(this, [ this.fp('__runCloseButton')])
    
    if( this.__path ){
        this.setIcon('back');
    }
    else{
        this.setIcon('default_close_gray');
    }
    
	
	this.__container
		.style('background-color', 'rgba(255,255,255,1)')
		.style('z-index', 2);
	
	this.__container.on('mousedown', function(e){
		e.stopPropagation();
	} );

	
	console.log("DialogChartMobile.__init", config);
	
	this.__config = config;
	this.__options = JSON.parse( config.file );
	

	if( config.key  ){
		this.__fixedKey = config.key;
		this.__fillWithReceivedMapKey = this.__options.field;
		
	}
	else if( config.params && config.params.info_config ){
		this.__fixedKey = config.params.info_config.key;
		this.__fillWithReceivedMapKey = (JSON.parse(config.params.info_config.file)).field;;
	}
	
	
// 	if( config.key  ){
//  		this.__fixedKey = config.key;
// 	}


// 	this.__requestBreadcrumb();

// 	this.append(
// 		DOM.create(DOM_TAG_DIV).append(
// 			this.__title = DOM.create(DOM_TAG_H1)
// 				.html( "Carregando...")
// 				.style("color", "#505050")
// 				.style("font-size", "14pt")
// 				.style("text-align", "center")
// 				.style("padding", "10px")
// 		)
// 		.on('click', this.fp('autoremove') )
// 	);
	
 	this.setTitle("Carregando...");
	

	Ajax.load( Path.action("bi/getAnalisys").addParam("analisys", this.__options.name).addParam("project", this.__options.project)  , "json")
		.on('load', this.fp('__onLoad') )
		.ready();
		

	//Adiciona solicitação ao log de acessos
	Ajax.load( Path.action("access/log").addParam("analisys", this.__options.name).addParam("project", this.__options.project), "json")
		.ready();
	
	this.on('insert', this.fp('__startOnInsert') );
	
	
	this.__onResizeHandler = this.fp('__onResize');
	
	Bus.getInstance().on('WINDOW_RESIZE',  this.__onResizeHandler );
	
// 	this.on('resize', this.fp('__onResize') );
	

    this.on('insert', this.__onResizeHandler );
}





DialogChartMobile.__requestBreadcrumb = function(){
	
	if( !this.__path ){
		this.__appendCloseButton();
		return;
	}
	
	var folders = Bus.getInstance().get('GET_USER_FOLDERS')();
	
	var fbreak = folders[0].split("/");
	fbreak.pop();
	fbreak = fbreak.join("/");


	var path = this.__path.replace( /^.*@LINK:/g, '');
	
	var psplit = path.split("/");
	
	
	var paths = [];
	

	while( true ){

		var pjoin = psplit.join("/");
		
		psplit.pop();
		
		if( pjoin == fbreak )
			break;
		
		paths.push(pjoin );
	}
	
	
	
	paths = paths.reverse();
	
	paths.pop();

	var path = Path.action('list').addParam('plugins[]', 'UserPlugin').addParam('project', PROJECT );
	
	Ajax.load(path, 'json')
		.on({
			'error': function( json ){},
			'load': this.fp('__receiveBreadcrumb')
		})
		.json({
			Item : {
				_action: 'list',
				_order: ['path'],
				_filter: ['path', '__IN__', paths],
				icon: null,
				name: null,
				path: null,
				type: null,
				file: null
			}
		})
		.ready();
		
		
// 	var bc = new Panel(window.innerWidth, '34px')
// 		.addContainerClass('breadcrumb');
//     
//     this.__bcPanel = bc;
// 	
// 	bc.behaviour( this.__sb = new ScrollBehaviour() );
// 	
// 	bc.append( this.__bcContent = DOM.create(DOM_TAG_DIV).html("carregando...").style("width", '1000px') );
// 	
// 	this.append( bc  );
}

DialogChartMobile.__appendCloseButton = function(){
	
	
// 	var bc = new Panel(window.innerWidth, '34px');
	
// 	bc.behaviour( this.__sb = new ScrollBehaviour() );
	
// 	bc.append( this.__bcContent = DOM.create(DOM_TAG_DIV).html("carregando...").style("width",  window.innerWidth + 'px') );
	
// 	this.append( bc  );
	
// 	this.__bcContent.empty();
	
	var image = Path.action('file/preview')
			.addParam('hash', 'default_close_gray' )
			.addParam('height', 60)
			.addParam('width', 60)
			.toURL();

	this.append(
		DOM.create(DOM_TAG_DIV)
			.html( "&nbsp;" )
			.style('display', 'block')
			.style('float', 'right')
			.style('padding-left', '30px')
			.style('padding-top', '10px')
			.style('padding-bottom', '10px')
			.style('padding-right', '5px')
			.style('background-image', 'url('+ image +')')
			.style('background-size', '30px 30px')
			.style('background-repeat', 'no-repeat')
			.style('background-position', '8px center')
			.on('mousedown', this.fp('__runCloseButton') ),

		DOM.create(DOM_TAG_DIV)
			.style("height", "1px")
			.style("clear", "both")
	);
	
//  	this.__sb.getExternalContent().scrollLeft( 1000 );
	
}

DialogChartMobile.__runCloseButton = function( e ){
	
    e.stopPropagation();
    
    if( this.__path ){
        
        var path = this.__path.split("/");
        
        path.pop();
        
        path = path.join("/");
        
        var item = {
//             "Item": {
                "_action": "new",
                "path": path,
                "name": path,
                "type": "FOLDER"
//             }
        };

        var service = Bus.getInstance().get('GET_ICON_SERVICE_CONNECTOR')( item );
        
        var handlerOptions = {};
		
		handlerOptions.context = this;
		
		service.activate( handlerOptions, item );
        

    }else{
        Bus.getInstance().launch('CLOSE_ALL_WINDOWS');
    }
	
}


DialogChartMobile.__closeCurrentFolder = function(){
	
	Bus.getInstance().get('SET_WINDOW_OPEN')( false );
	
	Bus.getInstance().getLauncher('CLOSE_ALL_WINDOWS');
	
	Bus.getInstance().launch('OPEN_MAIN_SCREEN');
	
}


DialogChartMobile.__receiveBreadcrumb = function( data ){
	console.log("DialogChartMobile::__receiveBreadcrumb", data);
	
	
// 	console.log("__SB__", this.__sb.getExternalContent().scrollLeft = 300 );

	this.__bcContent.empty();
	
	var image = Path.action('file/preview')
			.addParam('hash', 'default_close_gray' )
			.addParam('height', 60)
			.addParam('width', 60)
			.toURL();

	this.__bcContent.append(
		DOM.create(DOM_TAG_DIV)
			.html( "&nbsp;" )
			.style('display', 'block')
			.style('float', 'right')
			.style('padding-left', '30px')
			.style('padding-top', '10px')
			.style('padding-bottom', '10px')
			.style('padding-right', '5px')
			.style('background-image', 'url('+ image +')')
			.style('background-size', '30px 30px')
			.style('background-repeat', 'no-repeat')
			.style('background-position', '8px center')
			.on('click', this.fp('__closeCurrentFolder')  )
	);

	
	for(var i =data.Item.length -1; i >= 0; i-- ){
		
		var service = Bus.getInstance().get('GET_ICON_SERVICE_CONNECTOR')( data.Item[i] );
		
		var image = Path.action('file/preview')
			.addParam('hash', data.Item[i].icon )
			.addParam('height', 60)
			.addParam('width', 60)
			.toURL();
			
		this.__bcContent.append(
			DOM.create(DOM_TAG_DIV)
				.html( data.Item[i].name )
				.style('display', 'block')
				.style('float', 'right')
				.style('padding-left', '30px')
				.style('padding-top', '10px')
				.style('padding-bottom', '10px')
				.style('padding-right', '5px')
				.style('background-image', 'url('+ image +')')
				.style('background-size', '20px 20px')
				.style('background-repeat', 'no-repeat')
				.style('background-position', '8px center')
				.on('mousedown', this.rfp('__saveMouseDownPosition')  )
 				.on('click', this.rfp('__runIconService', [ service, data.Item[i] ])  )
		);
	}
	
	this.__sb.getExternalContent().scrollLeft( 1000 );
}


DialogChartMobile.__runIconService = function( service, config, e ){
	
	if( DOM.distance( e.clientX, e.clientY, this.__savedMouseDownX, this.__savedMouseDownY ) < 10 ){
		Bus.getInstance().launch('CLOSE_ALL_WINDOWS');
		
		var handlerOptions = {};
		
		handlerOptions.context = this;
		
		service.activate( handlerOptions, config );
	}
}


DialogChartMobile.__saveMouseDownPosition = function( e ){
	
	
	this.__savedMouseDownX = e.clientX;
	this.__savedMouseDownY = e.clientY;
	
	console.log("DialogOpenFolder.__saveMouseDownPosition", this.__savedMouseDownX, this.__savedMouseDownY);
	
}



// DialogChartMobile.__resizableFullScreen = function(){
// 	ResizableModal.prototype.__fullScreen.apply(this, arguments);
// }

// DialogChartMobile.__fullScreen = function(){
// 
// };


DialogChartMobile.__download = function( options ){
	
	var parentRenderConfig = this.__data.renders[ this.__parentRender ];
	console.log("DialogChartMobile::__download", options, parentRenderConfig );
	
	
	
	switch( options.subtype ){
		case "csv":
			this.__downloadCSV();
		break;
		
		case "png":
			
			if( parentRenderConfig.type != "TABLE_RENDER" && parentRenderConfig.type != "TABLE_RENDER_SIMPLE" )
				this.__downloadPNG();
			else
				Bus.getInstance().launch('NOTIFY', "As opções download em imagem, word ou pdf não estão disponíveis para tabelas.", 'error', 2000 )
		break;
		
		case "docx":
			
			if( parentRenderConfig.type != "TABLE_RENDER" && parentRenderConfig.type != "TABLE_RENDER_SIMPLE" )
				this.__downloadDOCX();
			else
				Bus.getInstance().launch('NOTIFY', "As opções download em imagem, word ou pdf não estão disponíveis para tabelas.", 'error', 2000 )
				
		break;
		
		case "pdf":
			
			if( parentRenderConfig.type != "TABLE_RENDER" && parentRenderConfig.type != "TABLE_RENDER_SIMPLE" )
				this.__downloadPDF();
			else
				Bus.getInstance().launch('NOTIFY', "As opções download em imagem, word ou pdf não estão disponíveis para tabelas.", 'error', 2000 )

		break;
		
		case "xslx":
			this.__downloadXSLX();
		break;

	}

}


DialogChartMobile.__downloadDOCX = function() {
	var title = $('header', this.__container.__element)[0].innerText;
	if (this.__chart.__container != undefined){
// 		var values = this.__form.getAllNamesWithSimpleValue();
		//		var chartCanvas = this.__chart.__container.getHTMLElement().toDataURL();

		var canvas =  this.__chart.__container.getHTMLElement();
		var contxt = canvas.getContext('2d');
		var w = canvas.width;
		var h = canvas.height;
// 		var data = contxt.getImageData(0, 0, w, h);
// 		var compositeOperation = contxt.globalCompositeOperation;
		contxt.globalCompositeOperation = "destination-over";
		contxt.fillStyle = "rgb(255,255,255)";
		contxt.fillRect(0,0,w,h);
		var chartCanvas = canvas.toDataURL();

		Ajax.load(Path.action('bi/getResult/docx')
			.addParam("project", this.__options.project), 'text')
			.on('load', this.fp('__downloadChartFile', ["application/vnd.openxmlformats-officedocument.wordprocessingml.document"]))
			.post({
				'text': (this.__data.attr_fonte || "") + " " + (this.__data.attr_anoreferencia ||  "" ) + " - " + this.__getFilterDescription(),
				'title': encodeURIComponent(title),
				'chart': encodeURIComponent(chartCanvas)
			})
			.ready();
	}else{
		var context = this.__container.getHTMLElement()
		var table = $('table', context).clone();
		var FTitle = $(table).find('tr:first').find('th:first');
		$(table).find('tr:first').remove();
		$(table).find('tr:first').prepend(FTitle);


		Ajax.load(Path.action('bi/getResult/docx')
			.addParam("project", this.__options.project), 'text')
			.on('load', this.fp('__downloadChartFile', ["application/vnd.openxmlformats-officedocument.wordprocessingml.document"]))
			.post({
				'text': (this.__data.attr_fonte || "") + " " + (this.__data.attr_anoreferencia ||  "" ) + " - " + this.__getFilterDescription(),
				'title': encodeURIComponent(title),
				'table': encodeURIComponent("<table>"+$(table)[0].innerHTML+"</table>")
			})
			.ready();
	}
}

DialogChartMobile.__downloadPDF = function(){
	var title = $('header', this.__container.__element)[0].innerText;
	if (this.__chart.__container != undefined) {
// 		var values = this.__form.getAllNamesWithSimpleValue();
//		var chartCanvas = this.__chart.__container.getHTMLElement().toDataURL();

		var canvas =  this.__chart.__container.getHTMLElement();
		var contxt = canvas.getContext('2d');
		var w = canvas.width;
		var h = canvas.height;
		contxt.globalCompositeOperation = "destination-over";
		contxt.fillStyle = "rgb(255,255,255)";
		contxt.fillRect(0,0,w,h);
		var chartCanvas = canvas.toDataURL();

		Ajax.load(Path.action('bi/getResult/pdf')
			.addParam("project", this.__options.project), 'text')
			.on('load', this.fp('__downloadChartFile', ["application/pdf;charset=UTF-8"]))
			.post({
				'text': (this.__data.attr_fonte || "") + " " + (this.__data.attr_anoreferencia ||  "" ) + " - " + this.__getFilterDescription(),
				'title': encodeURIComponent(title),
				'chart': encodeURIComponent(chartCanvas)
			})
			.ready();
	}else{
		var context = this.__container.getHTMLElement()
		var table = $('table', context).clone();
		var FTitle = $(table).find('tr:first').find('th:first');
		$(table).find('tr:first').remove();
		$(table).find('tr:first').prepend(FTitle);

		Ajax.load(Path.action('bi/getResult/pdf')
			.addParam("project", this.__options.project), 'text')
			.on('load', this.fp('__downloadChartFile', ["application/pdf;charset=UTF-8"]))
			.post({
				'text': (this.__data.attr_fonte || "") + " " + (this.__data.attr_anoreferencia ||  "" )+ " - " + this.__getFilterDescription(),
				'title': encodeURIComponent(title),
				'table': encodeURIComponent("<table>"+$(table)[0].innerHTML+"</table>")
			})
			.ready();
	}
}

DialogChartMobile.static.base64toBlob = function(base64Data, contentType) {
	contentType = contentType || '';
	var sliceSize = 1024;
	var byteCharacters = atob(base64Data);
	var bytesLength = byteCharacters.length;
	var slicesCount = Math.ceil(bytesLength / sliceSize);
	var byteArrays = new Array(slicesCount);

	for (var sliceIndex = 0; sliceIndex < slicesCount; ++sliceIndex) {
		var begin = sliceIndex * sliceSize;
		var end = Math.min(begin + sliceSize, bytesLength);

		var bytes = new Array(end - begin);
		for (var offset = begin, i = 0 ; offset < end; ++i, ++offset) {
			bytes[i] = byteCharacters[offset].charCodeAt(0);
		}
		byteArrays[sliceIndex] = new Uint8Array(bytes);
	}
	return new Blob(byteArrays, { type: contentType });
}

DialogChartMobile.__downloadChartFile = function(response, ContentType){
	response = JSON.parse(response);

	//TODO: Implementar dl via BLOB
	if(response['data_file'] != undefined){
		var blob = DialogChartMobile.base64toBlob(response['data_file'], ContentType);
		var url = window.URL.createObjectURL(blob);
		window.open(url);
	}else if(response['linkDoc'] != undefined){
		var path = Path.action("bi/getResult/dlFile")
			.addParam("project", this.__options.project)
			.addParam("file",  response['linkDoc'] );
		window.open(path.toURL());
	}
}

DialogChartMobile.__downloadXSLX = function(){

	var values = this.__form.getAllNamesWithSimpleValue();
	
	values.fixed_key = this.__fixedKey;

	var path = Path.action("bi/getResult/xslx")
		.addParam("text", (this.__data.attr_fonte || "") + " " + (this.__data.attr_anoreferencia ||  "" ) + " - " + this.__getFilterDescription() )
		.addParam("analisys", this.__options.name)
		.addParam("project", this.__options.project)
		.addParam("json",  JSON.stringify( values ) );
	
	window.open( path.toURL() )
}


DialogChartMobile.__downloadCSV = function(){
    
    var fattr = [];
    
    var arr = [];
    for(var prop in this.__lastReceivedData.result[0] )
        arr.push("\"" + prop + "\"");
	
	
	arr.push("fonte/filtro");
    
    fattr.push( arr.join(";") );
    
    for(var i = 0; i < this.__lastReceivedData.result.length; i++ ){
        var arr = [];
        
        for(var prop in this.__lastReceivedData.result[i] ){
            arr.push( "\"" + this.__lastReceivedData.result[i][prop]  + "\"" );
        }
        
        arr.push( (this.__data.attr_fonte || "") + " " + (this.__data.attr_anoreferencia ||  "" ) + " - " + this.__getFilterDescription() );
        
        fattr.push( arr.join(";") );
    }

    var str = fattr.join("\n");
  	var blob = new Blob([str], {type: 'text/csv;charset=utf-8'});
    var url  = window.URL || window.webkitURL;
    var link = document.createElementNS("http://www.w3.org/1999/xhtml", "a");
    link.href = url.createObjectURL(blob);
    link.download = 'table_' + new Date().getTime() + '.csv';
        
    var event = document.createEvent("MouseEvents");
    event.initEvent("click", true, false);
    link.dispatchEvent(event); 
}

DialogChartMobile.__downloadPNG = function(){

	var image = this.__chart.getRenderedImage();
	
	
	var img = new Image();
	
	var that = this;
	
	img.onload = function(){
		
		var cv = document.createElement("canvas");
		cv.width = img.width;
		cv.height = img.height + 200;
		
		cv.style.position = "absolute";

		document.body.appendChild( cv );
		
		var ctx = cv.getContext('2d');
		
		ctx.drawImage( img, 0, 0 );
		
		ctx.font="16px";
		
		ctx.fillText( (that.__data.attr_fonte || "") + " " + (that.__data.attr_anoreferencia ||  "" )+ " - " + that.__getFilterDescription() ,0, img.height );

		window.open( cv.toDataURL() );
		
		document.body.removeChild( cv );
		
	}
	
	img.src = image;

}

DialogChartMobile.__onResize = function(){
	
	var left = window.innerWidth * this.__desktop;
	
	if( window.innerWidth > window.innerHeight ){
		
		this.getContainer()
			.style('top', '0px')
			.style('left',  left + 'px')
			.style('height', '100%')
			.style('z-index', '99999999999999');
		
			
		this.__mainForm.getContainer().style('display', 'none')
		this.__form.getContainer().style('display', 'none');
		
		this.__sourceStringElement.style('display', 'none');

	}
	
	else{

		this.update( left, "37px", "100%", "calc(100% - 79px)" );
		
		this.__mainForm.getContainer().style('display', 'block');
		
		this.__sourceStringElement.style('display', 'block');
		
		if( this.__formVisible ){
			this.__form.getContainer().style('display', 'block');
		}
	
	}


	
	if( this.__chart ){
 		this.__chart.adjustToParent();
		this.__chart.redraw();
	}
	
	
// 	this.__bcPanel.setSize( window.innerWidth, 34 );
//     this.__sb.updateSizePanel();
// 	this.__sb.getExternalContent().scrollLeft( 1000 );
    
}

DialogChartMobile.__onLoad = function( data ){
	
	this.__data = data;
	
// 	if(data.info_context_modal)
// 		this.launch('show_context_modal');
// 	else 
		this.launch('show_info');
}

DialogChartMobile.__startOnInsert = function(){
	
 	this.setTitle( this.__data.name );
	
// 	this.__title.html( this.__data.name );
	
	
// 	this.__title
// 		.style('background-color', this.__data.title_bar_color )
// 		.style('color', this.__data.text_color )
// 	
// 		
// 	this.__btnFullScreen
// 		.style('background-color', this.__data.button_bar_color )
// 		
// 	this.__btnCloseModal
// 		.style('background-color', this.__data.button_bar_color )

	
	this.__container.stopPropagation('mousedown');
	
	this.__currentRender = this.__data.default_render;

// 	this.append( this.__filterElement = DOM.create(DOM_TAG_DIV).html("&nbsp;") );
	
 	this.__createForm( this.__data );
	

	
	this.__requestUpdateChart( this.__currentRender );
	
// 	set form to hide content
	this.__switchForm();
	this.__switchForm();
	
}


DialogChartMobile.__getFilterDescription = function(){
	
	var text = [];
	
	var final = "Filtrar";
	
	var names = this.__form.getAllNamesWithSemanticValue();
	
	for(var prop in names ){
		
		if( names[ prop ].value )
			text.push( names[ prop ].label + " " + names[ prop ].value );
	}
	
	var pop = text.pop();
	
	if( text.length > 0 )
		final = "Filtros: " + text.join("; ") + " e " + pop;
	else if( pop )
		final = "Filtros: " + pop;
	
	return final;
}


DialogChartMobile.__updateFilterDescription = function(){
	
	var final = this.__getFilterDescription();
	
	this.__filterButton.setLabel( final );
}


DialogChartMobile.__requestUpdateChart = function( render ){
	

// 	this.__buttonSetRender.setLabel( render );
	
	//console.log("__FILTER_TEXT__", this.__form.getAllNamesWithSemanticValue() );
	this.__updateFilterDescription();

	
	this.__parentRender = this.__currentRender;
	

	render = render || this.__currentRender;

	this.__currentRender = render;
	
	var values = this.__form.getAllNamesWithSimpleValue()
	
	if( this.__fixedKey ) 
		values['fixed_key'] = this.__fixedKey;
	
	if( this.__currentRequest)
		this.__currentRequest.abort();

	
	if( this.__data.required_inputs ){
		
		var not_ok_fields = [];
		for(var i = 0; i < this.__data.required_inputs.length; i++ ){
			
			var errInput = this.__form.find( this.__data.required_inputs[i] );
			errInput.cleanErrors();

			var value = values[ this.__data.required_inputs[i] ];
			
			if( !value || value == "" || (value instanceof Array && value.length == 0 ) ){

				errInput.addError("Campo Obrigatório");

				not_ok_fields.push( errInput.getLabel());
			}
			
		}
		
		if( not_ok_fields.length > 0 ){
			Bus.getInstance().launch('NOTIFY', "Os campos " + not_ok_fields.join(",") + " ainda não foram preenchidos.", "alert", 5000);
			
			if( this.__chart )
				this.__chart.getContainer().remove();

			return;
		}
	
	}
	
	console.info("__REQUEST_VALUES__", values );
	

	this.__currentRequest = Ajax.load(
			Path.action("bi/getResult")
				.addParam("analisys", this.__options.name)
				.addParam("project", this.__options.project),
			  
			"json"
		)
		.on('load', this.fp('__renderize'))
        .on('error', function(){
            console.error("Erro no PHP", arguments);
        })
		.json( values )
		.ready();
		
}


DialogChartMobile.__renderize = function( data ){
	
// 	if( data.success == false ){
	if( !data.success && SQL_DEBUG_MODE ){
		//Bus.getInstance().launch('NOTIFY', "Erro de SQL, a query gerada abrirá em nova aba", "error", 5000);
// 		console.clear();
		console.info( data.sql );
	}
		
	if( SQL_DEBUG_MODE && SQL_ALL_QUERYES ){
// 		console.clear();
		console.info( data.sql );
	}
	
	this.__lastReceivedData = data;

	if( this.__chart )
		this.__chart.getContainer().remove();

	data = data.result;

	if(data.length == 0){
		Bus.getInstance().launch('NOTIFY', "Não há informações para os critérios selecionados", "alert", 5000);
		return false;
	}
	
	var obj = {};
	var labels = {};
	var config = this.__data.renders[ this.__currentRender ];
	var options = config.options || {};
	
	for(var i = 0; i < data.length; i++){
		
		if( !labels[ data[i][ config.labelY ] ] )
			labels[ data[i][ config.labelY ] ] = true;
		
		if( !obj[ data[i][ config.labelX ] ] )
			obj[ data[i][ config.labelX ] ] = {};
		
		obj[ data[i][ config.labelX ] ][ data[i][config.labelY] ] = data[i][config.numeric]
	}
	
	for(var prop in obj){
		for(var label in labels ){
			if( obj[prop][ label ] == undefined  )
				obj[prop][ label ] = 0;
		}
	}
	

	for(var prop in obj){
		for(var label in labels ){
			
			if( label == "undefined"){
				obj[prop][ this.__data.name ] = obj[ prop ][ label ];
				delete obj[prop][ label ];
			}

		}
	}
	

	if( obj["undefined"] !== undefined ){
		obj[""] = obj["undefined"];
		delete obj["undefined"];
	}
	

 	console.log("__RENDER_DATA_TO_TEST__", JSON.stringify(obj, false, "\t"), data);
	
//   	return;

	switch( config.type ){
		
		case "SVG_REPLACE_RENDER":
			this.__chart = new SVGReplaceRender(100, 100, config, "mobile");
                        
            this.append( this.__chart );
            this.__chart.adjustToParent();
            this.__chart.updateData( data );
		break;
		
		case "LINE_CHART":
 			this.__chart = new LineChart2(100, 100, options);
// 			this.__chart = new BarChart2(100, 100, options);
                        
            this.append( this.__chart );
            this.__chart.adjustToParent();
            this.__chart.updateData( obj );
		break;
		
		case "BAR_CHART":
  			this.__chart = new BarChart2(100, 100, options);
// 
            this.append( this.__chart );
            this.__chart.adjustToParent();
             this.__chart.updateData( obj );
		break;

		case "PIE_CHART":
  			this.__chart = new PieChart2(100, 100, options);

            this.append( this.__chart );
            this.__chart.adjustToParent();
            this.__chart.updateData( obj );
		break;
		
		case "HORIZONTAL_BAR_CHART":
 			this.__chart = new HorizontalBarChart(100, 100, options);

            this.append( this.__chart );
            this.__chart.adjustToParent();
            this.__chart.updateData( obj );
		break;
		
		case "TABLE_RENDER":
			this.__chart = new TableRender(100, 100);
                        
            this.append( this.__chart );
            this.__chart.adjustToParent();
            this.__chart.updateData( obj );
            this.__chart.adjustToParent();
		break;
		
		case "TABLE_RENDER_SIMPLE":
			this.__chart = new TableRenderSimple(100, 100);
                        
            this.append( this.__chart );
            this.__chart.adjustToParent();
            this.__chart.updateData( data );
            this.__chart.adjustToParent();
			this.__chart.redraw();
		break;

		case "NEW_TABLE_RENDER":
			this.__chart = new NewTableRender(100, 100, config, this.__form );
                        
                        this.append( this.__chart );
                        this.__chart.adjustToParent();
                        this.__chart.updateData( data );
                        this.__chart.adjustToParent();
                        this.__chart.redraw();
		break;
		
		case "LIST_RENDER":
			this.__chart = new ListRender(100, 100);
                        
            this.append( this.__chart );
            this.__chart.adjustToParent();
            this.__chart.updateData( data );
            this.__chart.adjustToParent();
		break;

		case "EXTERNAL_RENDER":
			config.params.labelX = config.labelX;
			var func = eval( "window." + config.script_service );
			var html = func({width: 100, heigth: 100}, config.params, obj, data);
			this.append( this.__chart = DOM.create(DOM_TAG_DIV).html( html ) );
		break;
		
		case "ANALISYS_COLLECTION":
			
			var values = this.__form.getAllNamesWithSimpleValue()

			if( this.__fixedKey ) 
				values['fixed_key'] = this.__fixedKey;

			//TODO: Refatorar passagem destes dados
			var dados_cabecalho = {};
			$(this.__container.getHTMLElement()).find('select').each(function(){ var Key = $(this).prev()[0].innerHTML; $(this).find('option:selected').each(function(){ dados_cabecalho[Key] = this.innerHTML }) });
			new AnalysisPrinter( values, config, dados_cabecalho );

			
			this.__requestUpdateChart( this.__parentRender );
		break;
		
		
		case "FACEBOOK_SHARE":
			this.__facebookShare();
			this.__requestUpdateChart( this.__parentRender );
		break;
		
		
		case "DOWNLOAD":
			this.__download( config );
			this.__requestUpdateChart( this.__parentRender );
		break;

		default:
			alert("Implementar aqui.");
	}
	
}


DialogChartMobile.__facebookShare = function(){

	var instruction = [
		{
			file: JSON.stringify({
				name: this.__options.name,
				project: this.__options.project
			}),
			
			type: "ANALISYS"
		}
	];
	
	var url = "http://centro.sebraedata.com.br/toq/client/#sebrae" /*+ window.location.href*/ + "!!" + Util.encode( JSON.stringify( instruction ) );
	
// 	var final_url = "https://www.facebook.com/dialog/feed?app_id="+ 1655569024681398 +"&display=popup&caption="+ encodeURIComponent( this.__options.name ) +"&link=" + encodeURIComponent( url ) + "&redirect_uri=" + encodeURIComponent( url );
  
	var final_url =
		'http://www.facebook.com/sharer.php?p[title]=' +
		encodeURIComponent( this.__data.name ) +
		'&p[summary]=' +
		encodeURIComponent( this.__data.name ) +
		'&p[url]=' +
		 encodeURIComponent( url ) +
		'&p[images][0]=' +
		encodeURIComponent( "http://centro.sebraedata.com.br/toq/server/public/?action=file/preview&hash=default_left&height=200&width=200" );
	
//  	alert("DialogChartMobile::__facebookShare - " + final_url );
	
	window.open( final_url );
}


DialogChartMobile.__cloneWindow = function(){
	var box = this.getContainer().getBOX();
	
	DialogChartMobile.__EXECUTE__( {x: box.left + 50, y: box.top + 50, context: this }, this.__config );
}




DialogChartMobile.__showRelatedCharts = function(){
// 	alert("Indicadores relacionados");
	
	var cm = new ContextFeatureInfo( this.__buttonShowRelated, this, this.__data, this.__config);
 	Bus.getInstance().get('APPEND_APPLICATION_COMPONENT')( cm );

}


DialogChartMobile.__receiveDescription = function(h3, div, data){

 	h3.html( data.Item.name || "Item sem nome");
	div.html( data.Item.description || "Item sem descrição");

}

DialogChartMobile.__showDescription = function(){
	
	var cm = new ContextModal( 400, 'auto', this.__descriptionButton , ["bottom"] );

	if( this.__config.name && this.__config.description ){

		cm.append(
			DOM.create(DOM_TAG_H3).html( this.__config.name ),
			DOM.create(DOM_TAG_BR),
			DOM.create(DOM_TAG_DIV).html( this.__config.description ).style("text-align", "left") /*,*/
		);
	
	}
	
	else{
		
		var h3, div;
		cm.append(
			h3 = DOM.create(DOM_TAG_H3).html( "Carregando..." ),
			DOM.create(DOM_TAG_BR),
			div = DOM.create(DOM_TAG_DIV).html( "Carregando..." ).style("text-align", "left") /*,*/
		);
		
		
		Ajax.load( Path.action("list"), "json" )
			.json({
				"Item": {
					_action: "get",
					path: this.__data.original_item,
					name: null,
					description: null
				}
			})
			.on('load', this.rfp('__receiveDescription', [h3, div]))
			.ready();
	}
	
	Bus.getInstance().get('APPEND_APPLICATION_COMPONENT')( cm );
}


DialogChartMobile.__openExportDialog = function(){
	var options = [];

	for(var prop in this.__data.renders){
				
		if( this.__data.renders[prop].type == "DOWNLOAD" || this.__data.renders[prop].type == "FACEBOOK_SHARE" )
			options.push({
				text: prop,
				handler: this.rfp('__requestUpdateChart', [ prop ])
			});

	}
	
	var cm = new ContextGenericMenu( this.__buttonExport, options, ['bottom', 'left'] );
	
	Bus.getInstance().get('APPEND_APPLICATION_COMPONENT')( cm );
}



DialogChartMobile.__openSetRepresentationDialog = function(){
	var options = [];

	for(var prop in this.__data.renders){
				
		if( this.__data.renders[prop].type != "DOWNLOAD" && this.__data.renders[prop].type != "FACEBOOK_SHARE" &&  this.__data.renders[prop].type != "ANALISYS_COLLECTION" )
			options.push({
				text: prop,
				handler: this.rfp('__requestUpdateChart', [ prop ])
			});

	}
	
	var cm = new ContextGenericMenu( this.__buttonSetRender, options, ['bottom', 'left'] );
	
	Bus.getInstance().get('APPEND_APPLICATION_COMPONENT')( cm );	
}



DialogChartMobile.__createForm = function( data ){

	this.append(
		this.__mainForm = Form.create().append(
 			FormLine.create(10,90).append(

				this.__buttonSetRender =  Button.create("", "BT_SHOW_FILTER", false)
					.addContainerClass('BT_LINK')
					.addContainerClass('BT_IMAGE')
					.addContainerClass('BT_UNDERLINE')
					.setImage('default_view')
					.on('click', this.fp('__openSetRepresentationDialog') ),
					
				this.__filterButton = Button.create("Filtrar", "BT_SHOW_FILTER", false)
					.addContainerClass('BT_IMAGE')
					.addContainerClass('BT_UNIMPORTANT')
					.setImage('default_filter')
					.on('click', this.fp('__switchForm') )
					
			)
		)
	);
	
	
// 	this.append(
// 		this.__filterInfo = DOM.create(DOM_TAG_DIV)
// 			.addClass('filter')
// 			.html("Exibir filtro")
// 			.on('mousedown', this.fp('__switchForm') )
// 	);
	
	this.__inputMapping = data.inputs;
	
	this.__onChangeMapping = [];
	
	var form = Form.create();
	
	for(var i = 0; i < data.form.length; i++ ){
		var layout = [];
		
		var line = new FormLine();
		
		for(var j = 0; j < data.form[i].length; j++ )
			layout.push( data.form[i][j][0] );
		
		line.layout.apply(line, layout);
		
 		for(var j = 0; j < data.form[i].length; j++ )
 			line.append( this.__getInput( data.form[i][j], data ) );
		
		form.append( line );
		
	}
	
//	this.__loading.remove();
	
	this.append( form );
	this.__form = form;
	
	if( this.__fillWithReceivedMapKey && this.__fixedKey ){

		var input = this.__form.find( this.__fillWithReceivedMapKey );
		
		if( input )
			this.__fillParentWalkUp( input, this.__fixedKey );
	}
	
	else{
		this.__runAddAllSources();
	}
	
	this.append( this.__sourceStringElement = DOM.create(DOM_TAG_DIV).html( this.__data.attr_anoreferencia + " " + this.__data.attr_fonte ).style("color", "white").style("background-color", "#4D4D4D").style("text-align", "center") );

// 	this.__addOnChangeEventListner();

}



DialogChartMobile.__fillParentWalkUp = function( input, value  ){
	
	if( !this.__fillParentWalkUpCounter )
		this.__fillParentWalkUpCounter = 0;
	
	input.value( value, true /*prevent change event propagation*/ );

	var defs = this.__inputMapping[ input.getName() ];
	
	console.log("DialogChartMobile::__fillParentWalkUp", defs, input.getName() )
	
	if( defs.fillParentInput ){

		this.__fillParentWalkUpCounter++;

 		var parentInput = this.__form.find( defs.fillParentInput );
		
		Ajax.load(
			Path.action("bi/getList")
				.addParam("project", this.__options.project)
				.addParam("analisys", this.__options.name), "json"
		)
		.json(
			{
				filter: {
					__EQUAL__ : [
						defs.key,
						{ __VALUE__: value }
					]
				},
				label: defs.label, 
				key: defs.key,
				parentValue: defs.fillParentInputWith
			}
		)
		.on('load', this.rfp('__receiveParentWalkUpRequest', [parentInput]))
		.on('error', function(){ alert("Error on receive __receiveParentWalkUpRequest"); }  )
		.ready();

	}
	
	if( this.__fillParentWalkUpCounter == 0 ){
		this.__runAddAllSources();
		
		this.__requestUpdateChart();
	}

}


DialogChartMobile.__receiveParentWalkUpRequest = function( parentInput, data ){
	this.__fillParentWalkUpCounter--;
 	this.__fillParentWalkUp( parentInput, data.BI2Model[0].parentValue );
}






DialogChartMobile.__switchForm = function(){
	
	if( this.__formVisible ){
		this.__formVisible = false;
		this.__form.getContainer().style('display', 'none');
	}
	
	else{
		this.__formVisible = true;
		this.__form.getContainer().style('display', 'block');
	}
	
	if( this.__chart ){
 		this.__chart.adjustToParent();
		this.__chart.redraw();
	}
}


DialogChartMobile.__addOnChangeEventListner = function(){

	for(var prop in this.__onChangeMapping){
		var input = this.__form.find( prop );
		
		for(var i = 0; i < this.__onChangeMapping[prop].length; i++ )
			input.on('change', this.rfp('__updateDependentInput', [ this.__onChangeMapping[prop][i] ]));
	}
	

	var fields = this.__form.getAllNames();
	
	for(var i = 0; i < fields.length; i++ )
// 		if( !this.__onChangeMapping[ fields[i] ] ){
			this.__form.find( fields[i] ).on('change', this.rfp('__requestUpdateChart', [ undefined ]) );
// 		}

}


DialogChartMobile.__updateDependentInput = function( target ){

	var input = this.__form.find( target );
	
	var defs = this.__inputMapping[ target ];
	
	var filter = this.__resolveFilter( defs.filter, target );
	
  	input.clean();
	
	input.setPersistenceSource(
		Path.action("bi/getList")
			.addParam("project", this.__options.project)
			.addParam("analisys", this.__options.name),
		{
			filter: filter,
			key: defs.key,
			label: defs.label,
			order: defs.order,
			parentValue: defs.fillParentInputWith
		},
		{id: '{{key}}', value: '{{label}}', key: 'key'}
	);
	
   	input.launch("change");
}

DialogChartMobile.__launchUpdateChosen = function( select ){
	select.trigger("chosen:updated");
}


DialogChartMobile.__getInput = function( config, data ){
	
	var defs = data.inputs[ config[2] ];
	
	
    var value = undefined; 
    
    if( this.__options.options && this.__options.options[ config[2] ] ){
        value = this.__options.options[ config[2] ];
    }
    else if( defs.staticDefaultValue !== undefined ){
        value = defs.staticDefaultValue;
    }
    
	
	if( defs.type == "SIMPLE_SELECT"){
		var si = SimpleSelectInput.create(config[1], null, false, config[2]);
		
		if( value  !== undefined)
			si.value( value );
			
 		this.__addSource( si, defs, config[2] );
		
		si.on('updated', this.fp('__updateFilterDescription'));
		
		return si;
	}
	


// 	if( defs.type == "SIMPLE_SELECT"){
// 		var si = SelectInput.create(config[1], null, false, config[2]);
// 		
// 		if(defs.staticDefaultValue !== undefined)
// 			si.value( defs.staticDefaultValue );
// 			
//  		this.__addSource( si, defs, config[2] );
// 		
// 		si.on('updated', this.fp('__updateFilterDescription'));
// 		
// 		return si;
// 	}
	
	
	if( defs.type == "MULTIPLE_SELECT"){
		var si = MultipleSelectInput.create(config[1], null, true, config[2]);
        
        if( value  !== undefined)
			si.value( value );
        
		this.__addSource( si, defs, config[2] );
        
		
//  		si.getContainer().stopPropagation("mousedown", "mouseup", "mousemove");

		si.on('updated', this.fp('__updateFilterDescription'));
		
		return si;
	}
	
	
// 	if( defs.type == "MULTIPLE_SELECT"){
// 		var si = SelectInput.create(config[1], null, true, config[2]);
// 		this.__addSource( si, defs, config[2] );
// 		
//  		si.getContainer().stopPropagation("mousedown", "mouseup", "mousemove");
// 		
// // 		si.getContainer().attr('size', '1');
// 		
// 		var select = $("select", si.getContainer().getHTMLElement());
// 		
// // 		select.chosen({
// // 			width: "100%",
// // 			no_results_text: "Nenhum resultado foi encontrado para "
// // 		});
// 		
// 		select.attr('size', '1');
// 		
// 		select.change( si.getLauncher("change") )
// 		
// //  		si.on('updated', this.rfp('__launchUpdateChosen', [select]));
// 		
// 		si.on('updated', this.fp('__updateFilterDescription'));
// 		
// 		return si;
// 	}

	
	if( defs.type == "CHECKBOX_MULTIPLE"){
		var cb = CheckboxMultiple.create(config[1], config[2]);
		this.__addSource( cb, defs, config[2] );
		return cb;
	}
	
	
	if( defs.type == "BINARY_SELECT"){
		var cb = CheckboxSimple.create(config[1], config[2]);
        
        if( value  !== undefined)
			cb.value( value );
            
		return cb;
    }

}


DialogChartMobile.__runAddSource = function( input, defs, inputname ){
	
	if( !defs.filter ){

		input.setPersistenceSource(
			Path.action("bi/getList")
				.addParam("project", this.__options.project)
				.addParam("analisys", this.__options.name),
			{
				order: defs.order,
				key: defs.key,
				label: defs.label,
				parentValue: defs.fillParentInputWith
			},
			{id: '{{key}}', value: '{{label}}', key: 'key'}
		);
// 		.on('load', input.getLauncher('change') );
	
	}
	else{
		var filter = this.__resolveFilter( defs.filter, defs.fillParentInput );
		
		input.setPersistenceSource(
			Path.action("bi/getList")
				.addParam("project", this.__options.project)
				.addParam("analisys", this.__options.name),
			{
				key: defs.key,
				label: defs.label,
 				filter: filter
			},
			{id: '{{key}}', value: '{{label}}', key: 'key'}
		);
		
		this.__registerInputDependence( defs.filter, inputname );
	}
}


DialogChartMobile.__runAddAllSources = function(){

	for(var i = 0; i < this.__addSourceList.length; i++ )
		this.__runAddSource( this.__addSourceList[i][0], this.__addSourceList[i][1], this.__addSourceList[i][2] );
	
	this.__addOnChangeEventListner();
}


DialogChartMobile.__addSource = function( input, defs, inputname ){
	this.__addSourceList.push( [input, defs, inputname] );
}


DialogChartMobile.__registerInputDependence = function( defs, inputname ){
	console.log("DialogChartMobile::__registerInputDependence", arguments);
	
	
	if( defs instanceof Array ){
		for(var i = 0; i < defs.length; i++)
			this.__registerInputDependence( defs[i], inputname )
	}
		
	else{
		if( typeof defs != "object" || defs === null )
			return;
		
		
		if( defs.__INPUT__ ){
		
			if( !this.__onChangeMapping[ defs.__INPUT__ ] )
				this.__onChangeMapping[ defs.__INPUT__ ] = [];
			
			this.__onChangeMapping[ defs.__INPUT__ ].push( inputname );
			
			return;
		}
		
 		for(var prop in defs)
			var ret = this.__registerInputDependence( defs[prop], inputname );
		
	}
	
}



DialogChartMobile.__resolveFilter = function( defs, target ){
	//Retorna filtro caso as dependências do mesmo sejam válidas.
	
	if( defs instanceof Array ){
		var arr = [];
		
		for(var i = 0; i < defs.length; i++){
			var ret = this.__resolveFilter( defs[i], target )
			
			if( ret === undefined ){
				
				//return undefined;
				
				
			}
			else
				arr.push( ret );
		}
		
		return arr;
	}
		
	else{
		if( typeof defs != "object" || defs === null )
			return defs;
			
		if( defs.__INPUT__ )
			return this.__resolveFilterValue( defs.__INPUT__, target );
		
		var obj = {};
		
 		for(var prop in defs){
			var ret = this.__resolveFilter( defs[prop], target );

 			if( ret === undefined ){
 				//return undefined;
			}
			
			else{
				
				if( prop == "__AND__" || prop == "__OR__"){
					
					obj[ prop ] = ret;
					return obj;
				}
				
				else{
					
 					if( ret.length > 1 ){
						obj[ prop ] = ret;
						
						return obj;
					}
					
					else{
						return undefined;
					}
						
					
// 					else{
// 						obj[ prop ] = undefined;
// 					}

				}
			}
			
		}
		
		alert("Nunca chegará aqui...");
// 		return obj;
	}
	
}

DialogChartMobile.__resolveFilterValue = function( inputName, target ){

	var input = this.__form.find( inputName );
	
	if( !input )
		return undefined;
	
	var value = input.value();
	
	if( value === null || value == "" ){
		
		if( this.__inputMapping[ target ].allowPartialFilter )
			return undefined;
		else
			return {__VALUE__: -1 };
	}
	
	return {__VALUE__: value};
}

DialogChartMobile.__showContextModal = function(){
	var context = new AbsolutePanel(this.__handlerOptions.x, this.__handlerOptions.y, 1, 1);
	Bus.getInstance().get('APPEND_APPLICATION_COMPONENT')( context );
	
	var cm = new ContextFeatureInfo( context , this, this.__data, this.__config);
 	Bus.getInstance().get('APPEND_APPLICATION_COMPONENT')( cm );
}
