Class('DialogOpenFolder')
	//.extends('AbsolutePanel');
    .extends('FullMobilePanel');

DialogOpenFolder.static.__SERVICE__ = function( config ){
	return { 
		'isAlias': true,
		'activate': DialogOpenFolder.__EXECUTE__
	};
}


DialogOpenFolder.static.__EXECUTE__ = function( handlerOptions, config ){
	
	Bus.getInstance().launch("CLOSE_ALL_WINDOWS");
	
	var dialog = new DialogOpenFolder( handlerOptions.context, config );
	
	Bus.getInstance().launch('OPEN_MODAL', dialog);

}


DialogOpenFolder.__verifyRemoveWindow = function(){
	
	if( this.__desktop == Bus.getInstance().get('GET_CURRENT_DASHBOARD')() ){
		this.autoremove();
		Bus.getInstance().off('WINDOW_RESIZE', this.__onResizeHandler);
    }

}


DialogOpenFolder.autoremove = function(){
	
	console.log("DialogOpenFolder::autoremove", this.__path );
	
	Bus.getInstance().get('SET_WINDOW_OPEN')( false );
		
	Bus.getInstance().off("CLOSE_ALL_WINDOWS", this.__autoRemoveHandler);
		
	FullMobilePanel.prototype.autoremove.apply( this );

}

	
DialogOpenFolder.__init = function( context, config ){
	
	Bus.getInstance().get('SET_WINDOW_OPEN')( true );
    
// 	var left_walk = document.documentElement.clientWidth * currentDashboard;
	
// 	this.__desktop = currentDashboard;
	
	this.__autoRemoveHandler = this.fp('__verifyRemoveWindow');
	
	Bus.getInstance().on("CLOSE_ALL_WINDOWS", this.__autoRemoveHandler );

// 	ContextModal.prototype.__init.apply(this, ['150px', 'auto', context, ['left', 'right'] ] );
	FullMobilePanel.prototype.__init.apply(this, [ this.fp('__closeCurrentFolder') ]);
		
	console.info("DialogOpenFolder::__init", config);

	this.__container.style('background-color', 'rgba(255,255,255,0.85)')
		.style('z-index', 2);

	
	this.__container.on('mousedown', function(e){
		e.preventDefault();
		e.stopPropagation();
	} );
	
    
	this.__path = config.path;
    
    this.setTitle( config.name || "&nbsp;" );
	

	this.append(
		this.__loading = DOM.create(DOM_TAG_DIV).html("carregando...")
	);
	
	this.__requestBreadcrumb();
	
	
	
	var path = Path.action('list').addParam('plugins[]', 'UserPlugin').addParam('project', PROJECT );
	
	Ajax.load(path, 'json')
		.on({
			'error': function( json ){},
			'load': this.fp('__addIcons')
		})
		.json({
			Item : {
				_action: 'list',
				_order: ['position'],
				_filter: [
					'folder.path', '=', this.__path.replace( /^.*@LINK:/g, '')
				],
	   
// 				hidden: null,
				icon: null,
				path: null,
				type: null,
				tag: null,
				name: null,
				description: null,
				group: {
					groupName: null,
					description: null
				},
				file: null
			}
		})
		.ready();
		

    this.__onResizeHandler = this.fp('__onResize');
	
	Bus.getInstance().on('WINDOW_RESIZE',  this.__onResizeHandler );
    
    this.on('insert', this.__onResizeHandler );
}





DialogOpenFolder.__onResize = function(){
	
	var left = window.innerWidth * this.__desktop;
	
	if( window.innerWidth > window.innerHeight ){
		
		this.getContainer()
			.style('top', '0px')
			.style('left',  left + 'px')
			.style('height', '100%')
			.style('z-index', '99999999999999');
	}
	
	else{
		this.update( left, "37px", "100%", "calc(100% - 79px)" );
	}
	
	this.__bcPanel.setSize( window.innerWidth, 34 );
    
    this.__sb.updateSizePanel();
    
	this.__sb.getExternalContent().scrollLeft( 1000 );
    
    
    if( this.__listPanel ){
        this.__listPanel.setSize( this.innerWidth, 100 );
        this.__listPanel.adjustToParent();
    }
    
    
}




DialogOpenFolder.__requestBreadcrumb = function(){
	
	var folders = Bus.getInstance().get('GET_USER_FOLDERS')();
	
	var fbreak = folders[0].split("/");
	fbreak.pop();
	fbreak = fbreak.join("/");


	var path = this.__path.replace( /^.*@LINK:/g, '');
	
	var psplit = path.split("/");
	
	
	var paths = [];
	

	while( true ){

		var pjoin = psplit.join("/");
		
		psplit.pop();
		
		if( pjoin == fbreak )
			break;
		
		paths.push(pjoin );
	}
	
	
	
	paths = paths.reverse();
	
	paths.pop();

	var path = Path.action('list').addParam('plugins[]', 'UserPlugin').addParam('project', PROJECT );
	
	Ajax.load(path, 'json')
		.on({
			'error': function( json ){},
			'load': this.fp('__receiveBreadcrumb')
		})
		.json({
			Item : {
				_action: 'list',
				_order: ['path'],
				_filter: ['path', '__IN__', paths],
				icon: null,
				name: null,
				path: null,
				type: null,
				file: null
			}
		})
		.ready();
        
        
		
		
	var bc = new Panel(window.innerWidth, '34px')
		.addContainerClass('breadcrumb');
    
    this.__bcPanel = bc;
	
	bc.behaviour( this.__sb = new ScrollBehaviour() );
	
	bc.append( this.__bcContent = DOM.create(DOM_TAG_DIV).html("carregando...").style("width", '1000px') );
	
		
	this.append( bc  );
    
	
}


DialogOpenFolder.__closeCurrentFolder = function(){
    
	Bus.getInstance().get('SET_WINDOW_OPEN')( false );
	
	Bus.getInstance().launch('CLOSE_ALL_WINDOWS');
	
	Bus.getInstance().launch('OPEN_MAIN_SCREEN');
	
}


DialogOpenFolder.__receiveBreadcrumb = function( data ){
	console.log("DialogOpenFolder.__receiveBreadcrumb", data);
    
    if( data.Item[ data.Item.length -1 ] ){
        this.setTitle( data.Item[ data.Item.length -1 ].name );
    }
    
	this.__bcContent.empty();

	for(var i =data.Item.length -1; i >= 0; i-- ){
		
		var service = Bus.getInstance().get('GET_ICON_SERVICE_CONNECTOR')( data.Item[i] );
		
		var image = Path.action('file/preview')
			.addParam('hash', data.Item[i].icon )
			.addParam('height', 22)
			.addParam('width', 22)
			.toURL();
			
		this.__bcContent.append(
			DOM.create(DOM_TAG_DIV)
				.html( data.Item[i].name )
				.style('display', 'block')
				.style('float', 'right')
				.style('padding-left', '22px')
				.style('padding-top', '10px')
				.style('padding-bottom', '10px')
				.style('padding-right', '5px')
				.style('background-image', 'url('+ image +')')
				.style('background-size', '11px 11px')
				.style('background-repeat', 'no-repeat')
				.style('background-position', '8px center')
				.on('mousedown', this.rfp('__saveMouseDownPosition')  )
 				.on('click', this.rfp('__runIconService', [ service, data.Item[i] ])  )
		);
	}
	
	
	
	
	
 	this.__sb.getExternalContent().scrollLeft( 1000 );
    
    
    if( data.Item.length == 0){
//         alert("Remover BC");
        this.__bcPanel.remove();
    }
    
    
	
	
// 	this.__bcContent.append( DOM.create(DOM_TAG_DIV).html('&nbsp').style('clear', 'both') );
}



DialogOpenFolder.__saveMouseDownPosition = function( e ){
	
	
	this.__savedMouseDownX = e.clientX;
	this.__savedMouseDownY = e.clientY;
	
	console.log("DialogOpenFolder.__saveMouseDownPosition", this.__savedMouseDownX, this.__savedMouseDownY);
	
}


DialogOpenFolder.__addIcons = function( data ){
    
	this.__loading.remove();
    
    this.__listPanel = new Panel( window.innerWidth, 10);
    
//     this.__listPanel.getContainer().style('background-color', 'rgba(255,0,0, 0.1)');

    
    this.append( this.__listPanel );
    
    this.__listPanel.adjustToParent();
    
    
    this.__listPanel.behaviour( new ScrollBehaviour() );
    
	
	for(var i = 0; i < data.Item.length; i++ ){
		
		var service = Bus.getInstance().get('GET_ICON_SERVICE_CONNECTOR')( data.Item[i] );
		
		var image = Path.action('file/preview')
			.addParam('hash', data.Item[i].icon )
			.addParam('height', 44)
			.addParam('width', 44)
			.toURL();

		this.__listPanel.append(
			DOM.create(DOM_TAG_DIV)
				.html( data.Item[i].name || "&nbsp;" )
                
                
//                 .style("background-color", "rgba(0,0,0,0.1)")
                
				
				.style("background-repeat", "no-repeat")
				.style("border-bottom", "1px solid gray")
				
				.style("color", "#505050")

				.style("padding", "20px 0px 20px 33px")
				
				.style("background-position", "5px center")
				
				.style("background-size", "22px 22px")
				
// 				.style("margin", "10px")
				.style('background-image', 'url('+ image +')')
				
				.on('mousedown', this.rfp('__saveMouseDownPosition')  )
 				.on('click', this.rfp('__runIconService', [ service, data.Item[i] ])  )
		);
		
	}
	
	
}


DialogOpenFolder.__runIconService = function( service, config, e ){
	
	if( DOM.distance( e.clientX, e.clientY, this.__savedMouseDownX, this.__savedMouseDownY ) < 10 ){
		Bus.getInstance().launch('CLOSE_ALL_WINDOWS');
		
		var handlerOptions = {};
		
		handlerOptions.context = this;
		
		service.activate( handlerOptions, config );
	}
}
