Class('Legend')
	.extends('Panel')
	.events('activate', 'deactivate');
	
Legend.__init = function( name, layers, url, sh ){
	
	Panel.prototype.__init.apply(this, arguments);
	
	this.__container.addClass('legendItem');
	
	this.__service = sh;
	
	this.__layers = layers;
	this.__url = url;
	
	
	
	this.__container.behaviour(
		new DOMHoldBehaviour(1000, 10)
	);
	
//  	this.__container.on("hold", this.rfp('__showLayerMenu', [sh]));
	

	
	var parse = JSON.parse( sh.file );
	
	
	console.log("__PARSE__", parse);
	

    this.append(
        this.__menuButton = DOM.create(DOM_TAG_DIV)
            .html("&nbsp;")
            .addClass('legend_menu_icon')
            .style('width', '40px')
            .style('height', '51px')
            .style('float', 'left')
    );
    
    
	this.__menuButton.on("mousedown", this.rfp('__saveMouseDownPosition'));
	this.__menuButton.on("click", this.rfp('__showLayerMenu'));
    
    
    this.append( this.__childContainer = DOM.create(DOM_TAG_DIV).style('float', 'left') )
    
        
//     this.append(
//         DOM.create(DOM_TAG_DIV)
//             .html("&nbsp;")
//             .style('height', '1px')
//             .style('clear', 'both')
//     );

	
	if( parse.type == "heatmap" || url == "" ){
		this.drawLayerLogo( sh, name );
		
		this.__childContainer.append( DOM.create(DOM_TAG_DIV).style("clear", "both").style("height", "1px") );
	}
	
	else{

		this.__childContainer.append( DOM.create(DOM_TAG_H4).html(parse.analisysName + " " +parse.attr_anoreferencia + ", " + parse.attr_fonte));

		this.requestRedraw();
	}
	
	
//     this.__childContainer.append(
//         DOM.create(DOM_TAG_DIV)
//             .style('height', '1px')
//             .style('clear', 'both')
//     );

	
}


Legend.__saveMouseDownPosition = function( e ){
	
	
	this.__savedMouseDownX = e.clientX;
	this.__savedMouseDownY = e.clientY;
	
	console.log("DialogOpenFolder.__saveMouseDownPosition", this.__savedMouseDownX, this.__savedMouseDownY);
	
}




Legend.drawLayerLogo = function( sh, name ){

	var image = Path.action('file/preview')
			.addParam('hash', sh.icon )
			.addParam('height', 26 * window.devicePixelRatio)
			.addParam('width', 26 * window.devicePixelRatio)
			.toURL();
	
	this.__childContainer.append(
		DOM.create(DOM_TAG_DIV)
 			.style("padding-left", "30px")
			.style("padding-top", "23px")
			.style("height", '27px')
			.style("background-image", "url(\""+ image +"\")")
			.style("background-size", "26px 26px")
			.style("background-position", "left 18px")
			.style("background-repeat", "no-repeat")
			.html( name )
	);

}



Legend.requestRedraw = function(){
	
	this.__childContainer.append( this.__loading = DOM.create(DOM_TAG_SPAN).html('Carregando...') );
	
	if( this.__markersContainers instanceof Array ){
		
		for(var i = 0; i < this.__markersContainers.length; i++ )
			this.__markersContainers[i].remove();
		
		this.__markersContainers = [];
	}
	
	Ajax.load(Path.action('geo/getStyle'), 'json')
		.json({
			'url': this.__url,
			'layers': this.__layers
		})
		.on('load', this.fp('__renderStyle') )
		.ready();
	
}


Legend.__moveLayerToTop = function( sh ){
  
  Bus.getInstance().get('MAP_MOVE_LAYER_TOP')( sh );
  
}

Legend.__showLayerMenu = function( sh ){
	
	Bus.getInstance().get('APPEND_APPLICATION_COMPONENT')(
	  
		new ContextGenericMenu(
            this.__menuButton,
            [
                {
                    text: "Filtrar",
                    handler: this.fp('__doActivate')
                },            
                
                {
                    text: "Mover para cima",
                    handler: this.rfp('__moveLayerToTop', [ this.__service ])
                },
                
                {
                    text: "Remover",
                    handler: this.rfp('__removeLayer', [ this.__service ])
                }
            ],
            ['top']
        )

	);
	
}

Legend.__removeLayer = function( sh ){

	sh.activate( sh );
}


Legend.__doActivate = function( e ){

	Bus.getInstance().get('APPEND_APPLICATION_COMPONENT')( new DialogTOQLayerOptions( this.__menuButton, this,  this.__service ) );

}

Legend.__renderStyle = function( style ){
	this.__loading.remove();
	
	this.__clique && this.__clique.remove();

	this.__markersContainers = [];
	
	for( var i = 0; i < style.length; i++ ){
		var marker;
		var container;
		
		this.__childContainer.append(
			container = DOM.create(DOM_TAG_DIV).append(
				marker = DOM.create(DOM_TAG_DIV).addClass('legendMarker'),
				DOM.create(DOM_TAG_SPAN).html( style[i].name ).style("display", "block").style("float", "right").style("margin-top", "10px")
			)
			.style("float", "left")
		);
		
		if( style[i].symbol ){
// 			alert( style[i].symbol );
			
			marker.addClass('simbol');
			
			marker.style('background-image', 'url('+ ENGINE.contextRoot +'markers/'+ style[i].symbol +')');
		}
		
		if( style[i].fill )
			marker.style('background-color', style[i].fill);
		
		if( style[i].stroke )
			marker.style('border-color', style[i].stroke);
		
		if( style[i].type == 'line' ){
			marker.style('border-left-color', 'transparent');
			marker.style('border-top-color', 'transparent');
		}
		
		this.__markersContainers.push( container );
	}
	
	
// 	this.__childContainer.append( DOM.create(DOM_TAG_DIV).style("clear", "both").style("height", "1px") );
	
// 	this.__childContainer.append(
// 	    this.__clique = DOM.create(DOM_TAG_DIV).html("<br />Clique aqui para filtrar").style('text-align', 'right')
// 	);

}
