Class('LegendBar')
	.extends('Panel')
	.events('activate', 'deactivate');
	
LegendBar.__init = function(){
	Panel.prototype.__init.apply(this, arguments);
	
	this.behaviour( new ScrollBehaviour() );
	this.__visible = true;
	this.__legendContainers = {};
	this.__container.addClass('legendBar');
	
	Bus.getInstance()
// 		.on('UPDATE_WINDOW_POSITIONS', this.fp('__updatePositions') )
		.on('WINDOW_RESIZE', this.fp('__updatePositions') )
		.on('SELECT_VECTOR_FEATURE', this.fp('__showFeatureStyle') )
		.on('REGISTER_NEW_LAYER', this.fp('__registerNewLayer') );
	
	Bus.getInstance().get('REGISTER_ICON_SERVICE_CONNECTOR')(
		'SHOW_LEGEND',
		this.fp('__getConnector')
	);
	
	

	
// 	for(var i = 0; i < LAYERS.length; i++){
// 		
// 		var sh = Bus.getInstance().get('GET_ICON_SERVICE_CONNECTOR')({
// 			'type':'MAP_LAYER',
// 			'name': LAYERS[i].name
// 		});
// 		
// 		sh.activateConnector( this.rfp('__addLayerLegend', [ LAYERS[i], sh ]) );
// 		sh.deactivateConnector( this.rfp('__removeLayerLegend', [ LAYERS[i], sh ] ));
// 	}
        
        Bus.getInstance().on('SET_DASHBOARD_END', this.fp('__cleanLegend'));
}

LegendBar.__cleanLegend = function(){
    
    for(var prop in this.__legendContainers){
        this.__legendContainers[ prop ].getContainer().remove();
        delete this.__legendContainers[ prop ];
    }

    this.getContainer().style('display', 'none');
    
}


LegendBar.__showFeatureStyle = function( e ){
	
	if( e.selected ){
	
		for( var i = 0; i < e.selected.length; i++ ){
			
			var lf = new LegendFeature( e.selected[i] );
			
			this.append( lf );
			
			this.__appendContainer.prepend( lf.getContainer() /*DOM.create(DOM_TAG_DIV).html('teste')*/ );
		}
		
	}
	
	else{
		var lf = new LegendFeature( e.feature );
		
		this.append( lf );
		
		this.__appendContainer.prepend( lf.getContainer() /*DOM.create(DOM_TAG_DIV).html('teste')*/ );
	}
		

}


LegendBar.__registerNewLayer = function( layerConfig ){

	var options = JSON.parse( layerConfig.file );
	
	
	if( options.source == 'Vector')
		return;
	
 	var sh = Bus.getInstance().get('GET_ICON_SERVICE_CONNECTOR')( layerConfig );
	
 	if( options.source == 'TileWMS'){
		sh.activateConnector( this.rfp('__addLayerLegend', [sh, options.options.url, options.options.params.LAYERS ]) );
		sh.deactivateConnector( this.rfp('__removeLayerLegend', [sh, options.options.url, options.options.params.LAYERS ] ));
	}
	
	else{
		sh.activateConnector( this.rfp('__addLayerLegend', [sh, "", "" ]) );
		sh.deactivateConnector( this.rfp('__removeLayerLegend', [sh, "", "" ] ));
	}

}

LegendBar.__getLegendStatus = function(){
	return this.__visible;
}


LegendBar.__updatePositions = function(){

	if( window.innerWidth > window.innerHeight  )
		this.getContainer().style('bottom', '0px');
	else
		this.getContainer().style('bottom', '42px');

}

LegendBar.__addLayerLegend = function( sh, layers, url ){
	
	
	if( this.__legendContainers[ sh.name ] ){
		this.__legendContainers[ sh.name ].getContainer().remove();
		delete this.__legendContainers[ sh.name ];
	}
	
// 	var options = JSON.parse( sh.file );
	
 	this.__legendContainers[ sh.name ] = new Legend( sh.name, url, layers, sh );

  	this.append( this.__legendContainers[ sh.name ] );
 	
 	this.__appendContainer.prepend( this.__legendContainers[ sh.name ].getContainer() );
    
    
    this.getContainer().style('display', 'block');
    
}

LegendBar.__removeLayerLegend = function( sh ){
	
	if( this.__legendContainers[ sh.name ] ){
		this.__legendContainers[ sh.name ].getContainer().remove();
		delete this.__legendContainers[ sh.name ];
	}
}

LegendBar.setVisible = function( visibility ){
	
	this.__visible = visibility;
	
	if( this.__visible ){
		this.__container.style('display', 'block');
		this.launch('activate');
	}
	else{
		this.__container.style('display', 'none');
		this.launch('deactivate');
	}
}

LegendBar.__switchStatus = function(){
	this.__visible = !this.__visible;
	this.setVisible( this.__visible );
}

LegendBar.__getConnector = function(){
	return {
		'isAlias': true,
		'activateConnector': this.getConnector('activate'),
		'deactivateConnector': this.getConnector('deactivate'),
		'activate': this.fp('__switchStatus'),
		'status': this.fp('__getStatus')
	}
	
}

LegendBar.__getStatus = function(){
	return this.__visible;
}
