Class('LoginManager')
  .extends('Standart')
  
  
LoginManager.__init = function( handler, clock ){
	this.__afterLogin = handler;
	
	this.__clock = clock;

	Ajax.load(Path.action('user/status').addParam('project', PROJECT) , 'json')
		.on('load', this.fp('__verifyLogin'))
		.ready();
	
	Bus.getInstance().on('LOGOUT', this.fp('__logout'));
	
	Bus.getInstance().set('GET_CURRENT_USERNAME', this.fp('__getUserName') );
	
	Bus.getInstance().set('HAS_GROUP', this.fp('__hasGroup') );
	
 	Bus.getInstance().set('IS_PROJECT_ADMIN', this.fp('__isTemplateAdmin') );
	
	Bus.getInstance().set('GET_CURRENT_PROJECT', this.fp('__getCurrentProject') );
}

LoginManager.__getCurrentProject = function(){
	return this.__data.template;
}

LoginManager.__isTemplateAdmin = function(){
	return this.__hasGroup( this.__data.template + '.' + 'admin' );
}

LoginManager.__hasGroup = function( group ){
	return this.__data.groups.indexOf( group ) != -1;
}


LoginManager.__getUserName = function(){
	return this.__data.login;
}


LoginManager.updateData = function( data ){	
	this.__data = data;
}


LoginManager.__verifyLogin = function( data ){
	
	if( data.logged ){
		this.updateData( data );
		this.__afterLogin( data );
		this.__isLoged = true;
	}
	
	this.__providers = data.providers;

	this.__getDefaulWallpaper();
}


LoginManager.__getDefaulWallpaper = function(){
	
	Ajax.load(Path.action("list"), 'json')
		.json({
			"User" : {
				"_action": "get",
				"wallpaper": null,
				"icon": null,
				"userName": null,
				"autologin": {
					"login": null
				},
				"login": PROJECT
			}
		})
		.on('load', this.fp('__setWallpaper'))
		.on('load', this.fp('__verifyAutologin'))
		.ready();
		
}

LoginManager.__completeAutoLogin = function( data ){
	
	data.autologin = true;
	
	this.updateData( data );
	this.__afterLogin( data );
}


LoginManager.__requestAutoLogin = function( data ){
	
	Ajax.load(Path.action('user/login').addParam('project', PROJECT) , 'json')
		.on('load', this.fp('__completeAutoLogin'))
		.post({
			'login': data.User.autologin.login,
			'senha': 'Data12!@'
		})
		.ready();
	
}



LoginManager.__requestSolveCaptcha = function( data ){
    
    this.__requestAutoLogin(data);
    
// 	var dc = new DialogCaptcha( this.rfp('__requestAutoLogin', [data]) );
	
// 	Bus.getInstance().get('APPEND_APPLICATION_COMPONENT')( dc );



}



LoginManager.__verifyAutologin = function( data ){
	
	if( !this.__isLoged ){
		
		if( data.User.autologin.login ){
			//this.__requestSolveCaptcha( data )
            
            this.__requestAutoLogin( data );
		}
		
		else
			Bus.getInstance().get('APPEND_APPLICATION_COMPONENT')( new Login( this.__afterLogin, this, this.__providers ) );
		
	}
	
}


LoginManager.__setWallpaper = function( data ){
	
	if( !this.__isLoged )
		Bus.getInstance().launch('SET_CURRENT_WALLPAPER', data.User.wallpaper );
	
	Bus.getInstance().launch('SET_CURRENT_PROJECT_INFO', data.User.icon, data.User.userName );
	
}

LoginManager.__logout = function(){
	
	Ajax.load(Path.action("user/logout").addParam('project', PROJECT), 'json')
		.on('load', this.fp('__reloadPage'))
		.ready();
	
}


LoginManager.__reloadPage = function(){
	window.location.reload();
};
