Class('TaskBar')
	.extends('SidePanel');

TaskBar.static.create = function( side, tagName ){
	
	return new TaskBar( side, tagName );
}	

TaskBar.__init = function( side, tagName ){
	SidePanel.prototype.__init.apply(this, [ side ]);
	
	this.__left = [];
	this.__center = [];
	this.__right = [];
	
	this.__container.addClass( tagName );
	
	this.on('insert', 'updateCenterSize');
	
	this.__container.append(
		this.__end = DOM.create(DOM_TAG_DIV).style('clear', 'both')
	);
	
	this.setAppendContainer( this.__end ); 
	
	Bus.getInstance().on('WINDOW_RESIZE', this.fp('__onResize'));
    
    this.on('insert', this.fp('__onResize'));
}


TaskBar.__onResize = function(){
	
	if( window.innerWidth > window.innerHeight )
		this.getContainer().style('display', 'none');
	else
		this.getContainer().style('display', 'block');

}


TaskBar.updateCenterSize = function(){
	
	var left  = 0, right = 0;
	
	for(var i = 0; i < this.__left.length; i++)
 		left += this.__left[i].getContainer().getBOX().outerWidth;
	
 	for(var i = 0; i < this.__right.length; i++)
 		right += this.__right[i].getContainer().getBOX().outerWidth;
	
// 	this.__center[0].setMargin(left, right);
	
	this.__center[0]
		.getContainer()
		.style('margin-left', left)
		.style('margin-right', right);
}

TaskBar.left = function(){
 	for(var i = 0; i < arguments.length; i++){
		this.__left.push( arguments[i] )
		arguments[i].getContainer().style('float', 'left')
	}
	
	TaskBar.prototype.append.apply(this, arguments);
	
	return this;
}

TaskBar.center = function(){
	
   	for(var i = 0; i < arguments.length; i++){
 		this.__center.push( arguments[i] )
  	}
	
	TaskBar.prototype.append.apply(this, arguments);
	
	return this;
}

TaskBar.right = function(){
	
	 for(var i = 0; i < arguments.length; i++){
		this.__right.push( arguments[i] )
		arguments[i].getContainer().style('float', 'right')
	 }
	
	TaskBar.prototype.append.apply(this, arguments);
	
	return this;
}

