Class('UserWidget')
	.extends('HTMLComponent');

UserWidget.__init = function(){

	HTMLComponent.prototype.__init.apply(this, [DOM_TAG_DIV]);
	
	this.__userName = '';

	this.__container = DOM.create(DOM_TAG_DIV)
		.html('username')
		.addClass('__userWidget')
		.addClass('__topWidget')
		.stopPropagation('mousedown')
		.on('click', this.fp('__openUserMenu') );
	
	Bus.getInstance().on('SET_USERNAME', this.fp('__setUsername') );
	
	this.on('insert', this.fp('__saveTaskbar') );
}


UserWidget.__saveTaskbar = function( taskbar ){
	
	this.__taskbar = taskbar;
}

UserWidget.__setUsername = function( username ){
	this.__userName = username;
	
	this.getContainer().html( "&nbsp;" );
	
	this.__taskbar.updateCenterSize();
}


UserWidget.__openUserMenu = function( e ){
	Bus.getInstance().launch('WINDOW_MOUSEDOWN', this.getContainer(), e);
	Bus.getInstance().get('APPEND_APPLICATION_COMPONENT')( new ContextUserMenu( this, this.__userName ) );
}

	
UserWidget.getContainer = function(){
	
	return this.__container;
}

