Class('Workspace')
	.extends('AbsolutePanel')
	.events('insert', 'desktopSwitch', 'updateBackground');

Workspace.__init = function(){
	AbsolutePanel.prototype.__init.apply(this, []);


	this.update(0,0, '100%', '100%');
 	this.__container.addClass('workspace');

 	this.behaviour(
		this.__scrollBehaviour = new ScrollBehaviour()
	);

	Bus.getInstance().set('GET_DASHBOARD_COUNTER', this.fp('__getDashboardCounter') );
	Bus.getInstance().set('GET_CURRENT_DASHBOARD', this.fp('getCurrentDashboard'));
	
	Bus.getInstance().on('WINDOW_RESIZE', this.fp('__resizeWallpaper') );
	
	Bus.getInstance().on('WINDOW_RESIZE', this.fp('__reset') );

	
	Bus.getInstance().on('SET_DASHBOARD', this.fp('__setDashboard'));


	Bus.getInstance().on({
		'OPEN_MODAL': this.fp('__openModal'),
		'FOCUS_MODAL': this.fp('__focusModal')
	});

	this.on('insert', '__setStyleAppendContainer');
// 	this.on('scroll', '__updateBackgroundPosition');
	this.on('scrollend', '__calculateCurrentDesktop' );

	this.__container.append(

		this.__image = DOM.create(DOM_TAG_DIV)
			.style({
				'position': 'absolute',
				'z-index': '-2',
				'height': '100%',
				'width': '100%',
				'background-size': 'cover',
				'background-position': '75% 100%'
			})
	);

	Bus.getInstance().on('SET_CURRENT_WALLPAPER', this.fp('__setWallpaper'));
    
    
    Bus.getInstance().set('GET_CURRENT_WALLPAPER', this.fp('__getCurrentWallpaper') );
};



Workspace.__getCurrentWallpaper = function(){
    
    return this.__currentWallpaper;
}


Workspace.__reset = function(){
	
	this.__setDashboard( this.__currentDashboard );

}


Workspace.__resizeWallpaper = function(){	
	this.__setWallpaper( this.__currentWallpaper );
	
}

Workspace.__setWallpaper = function( wallpaper ){

	this.__currentWallpaper = wallpaper;
	
	var wpimage = 
		Path.action('file/preview')
				.addParam('hash', wallpaper)
				.addParam('height', 50)
				.toURL();
				
				
	var wpimage_final = 
		Path.action('file/preview')
				.addParam('hash', wallpaper)
				.addParam('height', Math.round(document.documentElement.clientHeight * window.devicePixelRatio /** 1.5*/))
				.toURL();
				
	this.__image.style('background-image', 'url('+ wpimage +')');
	
	
	var img = new Image();
	
	img.onload = this.rfp('__onPreloadImage', [ wpimage_final ]);
	
	img.src = wpimage_final;
}


Workspace.__onPreloadImage = function( wpimage_final ){

	this.__image.style('background-image', 'url('+ wpimage_final +')');

}


Workspace.__setStyleAppendContainer = function(){
	this.__appendContainer.style({
		width: '500%',
		height: '100%'
	});
};

Workspace.__calculateCurrentDesktop = function(x, y){

 	var w = this.__container.width();

	Bus.getInstance().launch('SET_DASHBOARD', Math.round( x  / w ));
}

// Workspace.__updateBackgroundPosition = function( x ){
// 	var des = 0.5 / ( this.__getDashboardCounter() - 1); 
// }

Workspace.getCurrentDashboard = function(){
	return this.__currentDashboard;
}

Workspace.__setDashboard = function( dashboard ){
	var scroll = dashboard * this.__container.width();
	
// 	var des = 0.5 / ( this.__getDashboardCounter() - 1); 
	

	this.__scrollBehaviour.getExternalContent().requestAnimationFrame(
		{ 'scrollLeft': scroll },
		300,
		DOM.__linear
	);

    
    if(this.__currentDashboard != dashboard ){
        this.__currentDashboard = dashboard;
        Bus.getInstance().launch('SET_DASHBOARD_END', dashboard);
    }
};

Workspace.__getDashboardCounter = function(){
	return DESKTOP_NUMBER;
};


Workspace.__openModal = function( modal ){
	this.append( modal );
}


Workspace.__focusModal = function( modal ){

	modal.getContainer().remove();

	this.__appendContainer.append(
		modal.getContainer()
	);

}
